package xyz.wbsite.dbtool.javafx.manger.callable;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import xyz.wbsite.dbtool.javafx.manger.FreeMarkerManager;
import xyz.wbsite.dbtool.javafx.manger.ManagerFactory;
import xyz.wbsite.dbtool.javafx.po.Doc;
import xyz.wbsite.dbtool.javafx.tool.DocRequestReader;
import xyz.wbsite.dbtool.javafx.tool.RequestReader;
import xyz.wbsite.dbtool.javafx.tool.ResponseReader;
import xyz.wbsite.dbtool.javafx.tool.Tool;
import xyz.wbsite.dbtool.web.frame.utils.FileUtil;

import javax.xml.parsers.DocumentBuilderFactory;
import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class DocCallable implements Callable {

    private File module;
    private File docFile;
    private List<Doc> ajaxDocList;
    private List<Doc> apiDocList;
    private Tool tool = new Tool();
    File docModule;
    private FreeMarkerManager freeMarkerManager;

    public DocCallable(File module, File docFile, List<Doc> docList) {
        this.module = module;
        this.docFile = docFile;
        this.ajaxDocList = docList;
        this.apiDocList = docList;
        this.freeMarkerManager = ManagerFactory.getFreeMarkerManager();
    }

    public Boolean call() throws Exception {
        if (!docFile.exists()) {
            docFile.mkdir();
        } else {
            Tool.clear(docFile);
        }

        String version = "1.0";

        File file = new File(module, "pom.xml");

        DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
        Document document = documentBuilderFactory.newDocumentBuilder().parse(file);

        Element documentElement = document.getDocumentElement();
        NodeList childNodes = documentElement.getChildNodes();
        for (int i = 0; i < childNodes.getLength(); i++) {
            Node item = childNodes.item(i);
            if (item.getNodeName().equals("version")) {
                version = item.getTextContent();
            }
        }

        List<Doc> ajaxList = new ArrayList<>();
        List<Doc> apiList = new ArrayList<>();
        for (Doc doc : ajaxDocList) {
            if (doc.isCheck()) {
                if ("ajax".equals(doc.getType().toLowerCase())) {
                    ajaxList.add(doc);
                }
                if ("api".equals(doc.getType().toLowerCase())) {
                    apiList.add(doc);
                }
            }
        }
        if (ajaxList.size() > 0) {
            File ajax = Tool.createFile(this.docFile, "ajax-" + version + ".html");
            for (Doc doc : ajaxList) {

                DocRequestReader requestReader = new DocRequestReader(doc.getRequestFile());
//                generateRequest(requestReader);

                ResponseReader responseReader = new ResponseReader(doc.getResponseFile());
//                generateResponse(responseReader);
            }
        }

        if (apiList.size() > 0) {
            File api = Tool.createFile(this.docFile, "api-" + version + ".html");
            for (Doc doc : apiList) {
                RequestReader requestReader = new RequestReader(doc.getRequestFile());
//                generateRequest(requestReader);

                ResponseReader responseReader = new ResponseReader(doc.getResponseFile());
//                generateResponse(responseReader);
            }
        }

        System.out.println("finish");
        return true;
    }

}
